package net.mcreator.moreenchantments.network;

import java.util.Objects;
import java.util.function.Supplier;
import net.mcreator.moreenchantments.MoreEnchantmentsMod;
import net.minecraft.client.Minecraft;
import net.minecraft.core.Direction;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.world.level.saveddata.SavedData;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.capabilities.CapabilityManager;
import net.minecraftforge.common.capabilities.CapabilityToken;
import net.minecraftforge.common.capabilities.ICapabilitySerializable;
import net.minecraftforge.common.capabilities.RegisterCapabilitiesEvent;
import net.minecraftforge.common.util.FakePlayer;
import net.minecraftforge.common.util.LazyOptional;
import net.minecraftforge.event.AttachCapabilitiesEvent;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.network.NetworkEvent;
import net.minecraftforge.network.PacketDistributor;
import net.minecraftforge.network.simple.SimpleChannel;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
/* loaded from: net_mcreator_moreenchantments_network.jar:net/mcreator/moreenchantments/network/MoreEnchantmentsModVariables.class */
public class MoreEnchantmentsModVariables {
    public static final Capability<PlayerVariables> PLAYER_VARIABLES_CAPABILITY = CapabilityManager.get(new CapabilityToken<PlayerVariables>() { // from class: net.mcreator.moreenchantments.network.MoreEnchantmentsModVariables.1
    });

    @SubscribeEvent
    public static void init(FMLCommonSetupEvent event) {
        MoreEnchantmentsMod.addNetworkMessage(SavedDataSyncMessage.class, SavedDataSyncMessage::buffer, SavedDataSyncMessage::new, SavedDataSyncMessage::handler);
        MoreEnchantmentsMod.addNetworkMessage(PlayerVariablesSyncMessage.class, PlayerVariablesSyncMessage::buffer, PlayerVariablesSyncMessage::new, PlayerVariablesSyncMessage::handler);
    }

    @SubscribeEvent
    public static void init(RegisterCapabilitiesEvent event) {
        event.register(PlayerVariables.class);
    }

    @Mod.EventBusSubscriber
    /* loaded from: net_mcreator_moreenchantments_network.jar:net/mcreator/moreenchantments/network/MoreEnchantmentsModVariables$EventBusVariableHandlers.class */
    public static class EventBusVariableHandlers {
        @SubscribeEvent
        public static void onPlayerLoggedInSyncPlayerVariables(PlayerEvent.PlayerLoggedInEvent event) {
            if (!event.getEntity().m_9236_().m_5776_()) {
                ((PlayerVariables) event.getEntity().getCapability(MoreEnchantmentsModVariables.PLAYER_VARIABLES_CAPABILITY, (Direction) null).orElse(new PlayerVariables())).syncPlayerVariables(event.getEntity());
            }
        }

        @SubscribeEvent
        public static void onPlayerRespawnedSyncPlayerVariables(PlayerEvent.PlayerRespawnEvent event) {
            if (!event.getEntity().m_9236_().m_5776_()) {
                ((PlayerVariables) event.getEntity().getCapability(MoreEnchantmentsModVariables.PLAYER_VARIABLES_CAPABILITY, (Direction) null).orElse(new PlayerVariables())).syncPlayerVariables(event.getEntity());
            }
        }

        @SubscribeEvent
        public static void onPlayerChangedDimensionSyncPlayerVariables(PlayerEvent.PlayerChangedDimensionEvent event) {
            if (!event.getEntity().m_9236_().m_5776_()) {
                ((PlayerVariables) event.getEntity().getCapability(MoreEnchantmentsModVariables.PLAYER_VARIABLES_CAPABILITY, (Direction) null).orElse(new PlayerVariables())).syncPlayerVariables(event.getEntity());
            }
        }

        @SubscribeEvent
        public static void clonePlayer(PlayerEvent.Clone event) {
            event.getOriginal().revive();
            PlayerVariables original = (PlayerVariables) event.getOriginal().getCapability(MoreEnchantmentsModVariables.PLAYER_VARIABLES_CAPABILITY, (Direction) null).orElse(new PlayerVariables());
            PlayerVariables clone = (PlayerVariables) event.getEntity().getCapability(MoreEnchantmentsModVariables.PLAYER_VARIABLES_CAPABILITY, (Direction) null).orElse(new PlayerVariables());
            clone.Drop = original.Drop;
            clone.DropMax = original.DropMax;
            clone.DropMin = original.DropMin;
            if (!event.isWasDeath()) {
                clone.DescendingTimeInAir = original.DescendingTimeInAir;
            }
        }

        @SubscribeEvent
        public static void onPlayerLoggedIn(PlayerEvent.PlayerLoggedInEvent event) {
            if (!event.getEntity().m_9236_().m_5776_()) {
                SavedData mapdata = MapVariables.get(event.getEntity().m_9236_());
                SavedData worlddata = WorldVariables.get(event.getEntity().m_9236_());
                if (mapdata != null) {
                    MoreEnchantmentsMod.PACKET_HANDLER.send(PacketDistributor.PLAYER.with(() -> {
                        return event.getEntity();
                    }), new SavedDataSyncMessage(0, mapdata));
                }
                if (worlddata != null) {
                    MoreEnchantmentsMod.PACKET_HANDLER.send(PacketDistributor.PLAYER.with(() -> {
                        return event.getEntity();
                    }), new SavedDataSyncMessage(1, worlddata));
                }
            }
        }

        @SubscribeEvent
        public static void onPlayerChangedDimension(PlayerEvent.PlayerChangedDimensionEvent event) {
            SavedData worlddata;
            if (!event.getEntity().m_9236_().m_5776_() && (worlddata = WorldVariables.get(event.getEntity().m_9236_())) != null) {
                MoreEnchantmentsMod.PACKET_HANDLER.send(PacketDistributor.PLAYER.with(() -> {
                    return event.getEntity();
                }), new SavedDataSyncMessage(1, worlddata));
            }
        }
    }

    /* loaded from: net_mcreator_moreenchantments_network.jar:net/mcreator/moreenchantments/network/MoreEnchantmentsModVariables$WorldVariables.class */
    public static class WorldVariables extends SavedData {
        public static final String DATA_NAME = "more_enchantments_worldvars";
        public double steeliness_v = 0.5d;
        public double armoring_v = 0.5d;
        public double sturdiness_v = 0.2d;
        public double furor_v = 0.75d;
        public double agility_v = 0.01d;
        public double range_v = 0.75d;
        public double chrysopoeia_c = 0.075d;
        public double compression_c = 0.05d;
        public double wisdom_v = 0.25d;
        public double extraction_v = 1.0d;
        public double reparation_c = 0.01d;
        public double leaping_v = 0.013d;
        public double beat_of_wings_v = 0.4d;
        public double beat_of_wings_d = 3.0d;
        public double iron_wings_v = 0.0d;
        static WorldVariables clientSide = new WorldVariables();

        public static WorldVariables load(CompoundTag tag) {
            WorldVariables data = new WorldVariables();
            data.read(tag);
            return data;
        }

        public void read(CompoundTag nbt) {
            this.steeliness_v = nbt.m_128459_("steeliness_v");
            this.armoring_v = nbt.m_128459_("armoring_v");
            this.sturdiness_v = nbt.m_128459_("sturdiness_v");
            this.furor_v = nbt.m_128459_("furor_v");
            this.agility_v = nbt.m_128459_("agility_v");
            this.range_v = nbt.m_128459_("range_v");
            this.chrysopoeia_c = nbt.m_128459_("chrysopoeia_c");
            this.compression_c = nbt.m_128459_("compression_c");
            this.wisdom_v = nbt.m_128459_("wisdom_v");
            this.extraction_v = nbt.m_128459_("extraction_v");
            this.reparation_c = nbt.m_128459_("reparation_c");
            this.leaping_v = nbt.m_128459_("leaping_v");
            this.beat_of_wings_v = nbt.m_128459_("beat_of_wings_v");
            this.beat_of_wings_d = nbt.m_128459_("beat_of_wings_d");
            this.iron_wings_v = nbt.m_128459_("iron_wings_v");
        }

        public CompoundTag m_7176_(CompoundTag nbt) {
            nbt.m_128347_("steeliness_v", this.steeliness_v);
            nbt.m_128347_("armoring_v", this.armoring_v);
            nbt.m_128347_("sturdiness_v", this.sturdiness_v);
            nbt.m_128347_("furor_v", this.furor_v);
            nbt.m_128347_("agility_v", this.agility_v);
            nbt.m_128347_("range_v", this.range_v);
            nbt.m_128347_("chrysopoeia_c", this.chrysopoeia_c);
            nbt.m_128347_("compression_c", this.compression_c);
            nbt.m_128347_("wisdom_v", this.wisdom_v);
            nbt.m_128347_("extraction_v", this.extraction_v);
            nbt.m_128347_("reparation_c", this.reparation_c);
            nbt.m_128347_("leaping_v", this.leaping_v);
            nbt.m_128347_("beat_of_wings_v", this.beat_of_wings_v);
            nbt.m_128347_("beat_of_wings_d", this.beat_of_wings_d);
            nbt.m_128347_("iron_wings_v", this.iron_wings_v);
            return nbt;
        }

        public void syncData(LevelAccessor world) {
            m_77762_();
            if (world instanceof Level) {
                Level level = (Level) world;
                if (!level.m_5776_()) {
                    SimpleChannel simpleChannel = MoreEnchantmentsMod.PACKET_HANDLER;
                    PacketDistributor packetDistributor = PacketDistributor.DIMENSION;
                    Objects.requireNonNull(level);
                    simpleChannel.send(packetDistributor.with(level::m_46472_), new SavedDataSyncMessage(1, this));
                }
            }
        }

        public static WorldVariables get(LevelAccessor world) {
            if (world instanceof ServerLevel) {
                ServerLevel level = (ServerLevel) world;
                return (WorldVariables) level.m_8895_().m_164861_(e -> {
                    return load(e);
                }, WorldVariables::new, DATA_NAME);
            }
            return clientSide;
        }
    }

    /* loaded from: net_mcreator_moreenchantments_network.jar:net/mcreator/moreenchantments/network/MoreEnchantmentsModVariables$MapVariables.class */
    public static class MapVariables extends SavedData {
        public static final String DATA_NAME = "more_enchantments_mapvars";
        public double leaden_wings_v = 2.0d;
        static MapVariables clientSide = new MapVariables();

        public static MapVariables load(CompoundTag tag) {
            MapVariables data = new MapVariables();
            data.read(tag);
            return data;
        }

        public void read(CompoundTag nbt) {
            this.leaden_wings_v = nbt.m_128459_("leaden_wings_v");
        }

        public CompoundTag m_7176_(CompoundTag nbt) {
            nbt.m_128347_("leaden_wings_v", this.leaden_wings_v);
            return nbt;
        }

        public void syncData(LevelAccessor world) {
            m_77762_();
            if ((world instanceof Level) && !world.m_5776_()) {
                MoreEnchantmentsMod.PACKET_HANDLER.send(PacketDistributor.ALL.noArg(), new SavedDataSyncMessage(0, this));
            }
        }

        public static MapVariables get(LevelAccessor world) {
            if (world instanceof ServerLevelAccessor) {
                ServerLevelAccessor serverLevelAcc = (ServerLevelAccessor) world;
                return (MapVariables) serverLevelAcc.m_6018_().m_7654_().m_129880_(Level.f_46428_).m_8895_().m_164861_(e -> {
                    return load(e);
                }, MapVariables::new, DATA_NAME);
            }
            return clientSide;
        }
    }

    /* loaded from: net_mcreator_moreenchantments_network.jar:net/mcreator/moreenchantments/network/MoreEnchantmentsModVariables$SavedDataSyncMessage.class */
    public static class SavedDataSyncMessage {
        public int type;
        public SavedData data;

        public SavedDataSyncMessage(FriendlyByteBuf buffer) {
            this.type = buffer.readInt();
            this.data = this.type == 0 ? new MapVariables() : new WorldVariables();
            SavedData savedData = this.data;
            if (savedData instanceof MapVariables) {
                MapVariables _mapvars = (MapVariables) savedData;
                _mapvars.read(buffer.m_130260_());
                return;
            }
            SavedData savedData2 = this.data;
            if (savedData2 instanceof WorldVariables) {
                WorldVariables _worldvars = (WorldVariables) savedData2;
                _worldvars.read(buffer.m_130260_());
            }
        }

        public SavedDataSyncMessage(int type, SavedData data) {
            this.type = type;
            this.data = data;
        }

        public static void buffer(SavedDataSyncMessage message, FriendlyByteBuf buffer) {
            buffer.writeInt(message.type);
            buffer.m_130079_(message.data.m_7176_(new CompoundTag()));
        }

        public static void handler(SavedDataSyncMessage message, Supplier<NetworkEvent.Context> contextSupplier) {
            NetworkEvent.Context context = contextSupplier.get();
            context.enqueueWork(() -> {
                if (!context.getDirection().getReceptionSide().isServer()) {
                    if (message.type == 0) {
                        MapVariables.clientSide = (MapVariables) message.data;
                    } else {
                        WorldVariables.clientSide = (WorldVariables) message.data;
                    }
                }
            });
            context.setPacketHandled(true);
        }
    }

    @Mod.EventBusSubscriber
    /* loaded from: net_mcreator_moreenchantments_network.jar:net/mcreator/moreenchantments/network/MoreEnchantmentsModVariables$PlayerVariablesProvider.class */
    private static class PlayerVariablesProvider implements ICapabilitySerializable<Tag> {
        private final PlayerVariables playerVariables = new PlayerVariables();
        private final LazyOptional<PlayerVariables> instance = LazyOptional.of(() -> {
            return this.playerVariables;
        });

        private PlayerVariablesProvider() {
        }

        @SubscribeEvent
        public static void onAttachCapabilities(AttachCapabilitiesEvent<Entity> event) {
            if ((event.getObject() instanceof Player) && !(event.getObject() instanceof FakePlayer)) {
                event.addCapability(new ResourceLocation("more_enchantments", "player_variables"), new PlayerVariablesProvider());
            }
        }

        public <T> LazyOptional<T> getCapability(Capability<T> cap, Direction side) {
            return cap == MoreEnchantmentsModVariables.PLAYER_VARIABLES_CAPABILITY ? this.instance.cast() : LazyOptional.empty();
        }

        public Tag serializeNBT() {
            return this.playerVariables.writeNBT();
        }

        public void deserializeNBT(Tag nbt) {
            this.playerVariables.readNBT(nbt);
        }
    }

    /* loaded from: net_mcreator_moreenchantments_network.jar:net/mcreator/moreenchantments/network/MoreEnchantmentsModVariables$PlayerVariables.class */
    public static class PlayerVariables {
        public ItemStack Drop = ItemStack.f_41583_;
        public double DropMax = 1.0d;
        public double DropMin = 1.0d;
        public double DescendingTimeInAir = 0.0d;

        public void syncPlayerVariables(Entity entity) {
            if (entity instanceof ServerPlayer) {
                ServerPlayer serverPlayer = (ServerPlayer) entity;
                MoreEnchantmentsMod.PACKET_HANDLER.send(PacketDistributor.PLAYER.with(() -> {
                    return serverPlayer;
                }), new PlayerVariablesSyncMessage(this));
            }
        }

        public Tag writeNBT() {
            CompoundTag nbt = new CompoundTag();
            nbt.m_128365_("Drop", this.Drop.m_41739_(new CompoundTag()));
            nbt.m_128347_("DropMax", this.DropMax);
            nbt.m_128347_("DropMin", this.DropMin);
            nbt.m_128347_("DescendingTimeInAir", this.DescendingTimeInAir);
            return nbt;
        }

        public void readNBT(Tag Tag) {
            CompoundTag nbt = (CompoundTag) Tag;
            this.Drop = ItemStack.m_41712_(nbt.m_128469_("Drop"));
            this.DropMax = nbt.m_128459_("DropMax");
            this.DropMin = nbt.m_128459_("DropMin");
            this.DescendingTimeInAir = nbt.m_128459_("DescendingTimeInAir");
        }
    }

    /* loaded from: net_mcreator_moreenchantments_network.jar:net/mcreator/moreenchantments/network/MoreEnchantmentsModVariables$PlayerVariablesSyncMessage.class */
    public static class PlayerVariablesSyncMessage {
        public PlayerVariables data;

        public PlayerVariablesSyncMessage(FriendlyByteBuf buffer) {
            this.data = new PlayerVariables();
            this.data.readNBT(buffer.m_130260_());
        }

        public PlayerVariablesSyncMessage(PlayerVariables data) {
            this.data = data;
        }

        public static void buffer(PlayerVariablesSyncMessage message, FriendlyByteBuf buffer) {
            buffer.m_130079_(message.data.writeNBT());
        }

        public static void handler(PlayerVariablesSyncMessage message, Supplier<NetworkEvent.Context> contextSupplier) {
            NetworkEvent.Context context = contextSupplier.get();
            context.enqueueWork(() -> {
                if (!context.getDirection().getReceptionSide().isServer()) {
                    PlayerVariables variables = (PlayerVariables) Minecraft.m_91087_().f_91074_.getCapability(MoreEnchantmentsModVariables.PLAYER_VARIABLES_CAPABILITY, (Direction) null).orElse(new PlayerVariables());
                    variables.Drop = message.data.Drop;
                    variables.DropMax = message.data.DropMax;
                    variables.DropMin = message.data.DropMin;
                    variables.DescendingTimeInAir = message.data.DescendingTimeInAir;
                }
            });
            context.setPacketHandled(true);
        }
    }
}
